#include "testApp.h"

#include "ofMeshUtils.h"

using namespace ofxCv;
using namespace cv;

void testApp::setup() {
	ofSetVerticalSync(true);
	
	cam.initGrabber(640, 480);
	tracker.setup();
	calibration.load("mbp-isight.yml");
    ofSetDrawBitmapMode(OF_BITMAPMODE_MODEL_BILLBOARD);

	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	light.setPosition(-500, 0, 0);
    
    
   v1.set(0,0, 1);          n1.set(0, 0);
    v2.set(0, 100, 1);        n2.set(0, 100);
    v3.set(0, 200, 1);        n3.set(0, 200);
    v4.set(0, 300, 1);        n4.set(0, 300);
    v5.set(0, 400, 1);        n5.set(0, 400);
    v6.set(0, 500, 1);        n6.set(0, 500);
    v7.set(0, 480, 1);        n7.set(0, 460);
    v8.set(100, 480, 1);      n8.set(100, 460);
    v9.set(200, 480, 1);      n9.set(200, 460);
    v10.set(300, 480,1);      n10.set(300, 480);
    v11.set(400, 480, 1);     n11.set(400, 480);
    v12.set(500, 480, 1);     n12.set(500, 480);
    v13.set(600, 480, 1);     n13.set(600, 480);
    v14.set(680, 480, 1);     n14.set(680, 480);
    v15.set(680, 400, 1);     n15.set(680, 400);
    v16.set(680, 300, 1);     n16.set(680, 300);
    v26.set(680, 200, 1);     n26.set(680, 200);
    v25.set(680, 100, 1);     n25.set(680, 100);
    v24.set(680, 0, 1);       n24.set(680, 0);
    v23.set(600, 0, 1);       n23.set(600, 0);
    v22.set(500, 0, 1);       n22.set(500, 0);
    v21.set(400, 0, 1);       n21.set(400, 0);
    v20.set(300, 0, 1);       n20.set(300, 0);
    v19.set(200, 0, 1);       n19.set(200, 0);
    v18.set(100, 0, 1);       n18.set(100, 0);
    v17.set(0, 0, 1);        n17.set(0,0);
                                            
    edge_3.push_back(toCv(v1));      edge_2.push_back(toCv(n1));
    edge_3.push_back(toCv(v2));      edge_2.push_back(toCv(n2)); 
    edge_3.push_back(toCv(v3));      edge_2.push_back(toCv(n3)); 
    edge_3.push_back(toCv(v4));      edge_2.push_back(toCv(n4)); 
    edge_3.push_back(toCv(v5));      edge_2.push_back(toCv(n5)); 
    edge_3.push_back(toCv(v6));      edge_2.push_back(toCv(n6)); 
    edge_3.push_back(toCv(v7));      edge_2.push_back(toCv(n7)); 
    edge_3.push_back(toCv(v8));      edge_2.push_back(toCv(n8)); 
    edge_3.push_back(toCv(v9));      edge_2.push_back(toCv(n9)); 
    edge_3.push_back(toCv(v10));     edge_2.push_back(toCv(n10));
    edge_3.push_back(toCv(v11));     edge_2.push_back(toCv(n11));
    edge_3.push_back(toCv(v12));     edge_2.push_back(toCv(n12));
    edge_3.push_back(toCv(v13));     edge_2.push_back(toCv(n13));
    edge_3.push_back(toCv(v14));     edge_2.push_back(toCv(n14));
    edge_3.push_back(toCv(v15));     edge_2.push_back(toCv(n15));
    edge_3.push_back(toCv(v16));     edge_2.push_back(toCv(n16));
    edge_3.push_back(toCv(v17));     edge_2.push_back(toCv(n17));
    edge_3.push_back(toCv(v18));     edge_2.push_back(toCv(n18));
    edge_3.push_back(toCv(v19));     edge_2.push_back(toCv(n19));
    edge_3.push_back(toCv(v20));     edge_2.push_back(toCv(n20));
    edge_3.push_back(toCv(v21));     edge_2.push_back(toCv(n21));
    edge_3.push_back(toCv(v22));     edge_2.push_back(toCv(n22));
    edge_3.push_back(toCv(v23));     edge_2.push_back(toCv(n23));
    edge_3.push_back(toCv(v24));     edge_2.push_back(toCv(n24));
    edge_3.push_back(toCv(v25));     edge_2.push_back(toCv(n25));
    edge_3.push_back(toCv(v26));     edge_2.push_back(toCv(n26));
}

void testApp::updatePhysicalMesh() {
    jaw = tracker.getImageFeature(ofxFaceTracker::FACE_OUTLINE);
    jaw_vert = jaw.getVertices(); // vector<ofPoint -> ofVec3f>
    vector<Point2f> border_2;
    vector<Point3f> border_3;
   
        for(int i = 1; i< 27; i++)
    {
        border_2.push_back(edge_2[i]);
        border_2.push_back(toCv(tracker.getImagePoint(i)));
        border_3.push_back(edge_3[i]);
        border_3.push_back(toCv(tracker.getObjectPoint(i)));
    }
   
    
    Mat cameraMatrix = calibration.getDistortedIntrinsics().getCameraMatrix();
    Mat distCoeffs = calibration.getDistCoeffs();
    Mat mew_vec, t_meow_vec;
    
    solvePnP(Mat(border_3), Mat(border_2), cameraMatrix, distCoeffs, mew_vec, t_meow_vec);
    
    
    vector<ofVec3f> altered_fitWorldPoints;
    Mat cameraMatrixInv = cameraMatrix.inv();
    Mat rmat, lmat;
    
    Rodrigues(mew_vec, lmat); ///converts rotation vector to rotation matrix or vice versa using Rodrigues transformation
    for(int i =0; i < border_2.size(); i++)
    {
        Point2d imgImg = border_2[i];
        Point3d objObj = border_3[i]; //same as above
        Point3d imgHom(imgImg.x, imgImg.y, 1.); // img->hom  change 2d points to 3d points
        Point3d imgWor = (Point3f) Mat(cameraMatrixInv * Mat(imgHom)); // hom->wor
        Point3d objWor = (Point3d) Mat(t_meow_vec+ lmat * Mat(objObj)); // obj->wor
        Point3d fitWor = intersectPointRay(objWor, imgWor); // scoot it over
        // if it was projected on the wrong side, flip it over
        if(fitWor.z < 0) {
            fitWor *= -1;
        }
        
        
        // convert down to image space coordinates
        Point3d fitHom = (Point3d) Mat(cameraMatrix * Mat(fitWor)); // wor->hom
        Point2d fitImg(fitHom.x / fitHom.z, fitHom.y / fitHom.z); // hom->img
        
        altered_fitWorldPoints.push_back(toOf(fitWor));
    }
    // 4 use the resulting 3d points to build a mesh with normals
   
    meow_physicalMesh = convertFromIndices(tracker.getMesh(altered_fitWorldPoints));
    meow_physicalMesh.setMode(OF_PRIMITIVE_TRIANGLES);
    buildNormals(meow_physicalMesh);
}

void testApp::update() {
	cam.update();
	if(cam.isFrameNew()) {
		tracker.update(toCv(cam));
        if(tracker.getFound()){
            otherShiz();
			updatePhysicalMesh();
        }
        position = tracker.getPosition();
        scale = tracker.getScale();
        orientation = tracker.getOrientation();
        
        
	}
}

void testApp::otherShiz(){
    jaw = tracker.getImageFeature(ofxFaceTracker::FACE_OUTLINE);
    jaw_vert = jaw.getVertices(); // vector<ofPoint -> ofVec3f>
    vector<Point2f> f2_vector;
    vector<Point3f> f3_vector;
    
    for(int i = 0; i < tracker.size(); i++){
            f2_vector.push_back(toCv(tracker.getImagePoint(i)));
            f3_vector.push_back(toCv(tracker.getObjectPoint(i)));
    }
    
   
    Mat cameraMatrix = calibration.getDistortedIntrinsics().getCameraMatrix();
    Mat distCoeffs = calibration.getDistCoeffs();
    Mat rvec, tvec;
    Mat mew_vec, t_meow_vec;
    
    solvePnP(Mat(f3_vector), Mat(f2_vector), cameraMatrix, distCoeffs, rvec, tvec);
    
    
    vector<ofVec3f> fitWorldPoints;
    vector<ofVec3f> altered_fitWorldPoints;
    Mat cameraMatrixInv = cameraMatrix.inv();
    Mat rmat, lmat;
    
    Rodrigues(rvec, rmat);
    for(int i = 0; i < f3_vector.size(); i++)
    {
        Point2d imgImg = f2_vector[i];
        Point3d objObj = f3_vector[i]; //same as above
        Point3d imgHom(imgImg.x, imgImg.y, 1.); // img->hom  change 2d points to 3d points
        Point3d imgWor = (Point3f) Mat(cameraMatrixInv * Mat(imgHom)); // hom->wor
        Point3d objWor = (Point3d) Mat(tvec + rmat * Mat(objObj)); // obj->wor
        Point3d fitWor = intersectPointRay(objWor, imgWor); // scoot it over
        // if it was projected on the wrong side, flip it over
        if(fitWor.z < 0) {
            fitWor *= -1;
        }
        fitWorldPoints.push_back(toOf(fitWor));
        
        // convert down to image space coordinates
        Point3d fitHom = (Point3d) Mat(cameraMatrix * Mat(fitWor)); // wor->hom
        Point2d fitImg(fitHom.x / fitHom.z, fitHom.y / fitHom.z); // hom->img
    }

    // 4 use the resulting 3d points to build a mesh with normals
   
    physicalMesh = convertFromIndices(tracker.getMesh(fitWorldPoints));
    physicalMesh.setMode(OF_PRIMITIVE_TRIANGLES);
    buildNormals(physicalMesh);
}

void testApp::draw() {
	//ofSetColor(0);
	//cam.draw(0, 0);
    ofDrawBitmapString(ofToString((int) ofGetFrameRate()), 10, 20);

	if(tracker.getFound()) {
		//calibration.getDistortedIntrinsics().loadProjectionMatrix();
        
        ofTranslate((cam.width)/2, (cam.height)/2);
        applyMatrix(tracker.getRotationMatrix());
        ofScale(15, 15, 15);
        //ofDrawAxis(scale);
        tracker.getObjectMesh().drawWireframe();
        //tracker.draw(true);
        
		//ofEnableLighting();
		//light.enable();
		//physicalMesh.drawWireframe();
        //meow_physicalMesh.drawWireframe();
	}
}

void testApp::keyPressed(int key) {
	if(key == 'r') {
		tracker.reset();
	}
}